// File automatically generated by ESPAM

#include "Times212_reshape0.h"
#include <stdlib.h>
#include <iostream>
#include "csdfNode.h"
#include "appMain.h"
#include "appFunc.h"
#include "fifo.h"
#include <cstddef>
#include "types.h"
#include <vector>
#include <string>
using namespace std;

Times212_reshape0::Times212_reshape0() : csdfNode() {
  //assign FIFO sizes
  IP0_fifo_size = 256;
  OP0_fifo_size = 256;

  int_params["Pooling160_dims"] = Pooling160_dims;
  int_params["Pooling160_dim_0"] = Pooling160_dim_0;
  int_params["Pooling160_dim_1"] = Pooling160_dim_1;
  int_params["Pooling160_dim_2"] = Pooling160_dim_2;
  int_params["output_dims"] = output_dims;
  int_params["output_dim_0"] = output_dim_0;
  int_params["output_dim_1"] = output_dim_1;
  int_params["output_dim_2"] = output_dim_2;
}
Times212_reshape0::~Times212_reshape0() {}

void Times212_reshape0::main(void *threadarg) {
  // create communication channel
  thread_info *thread_data;
  thread_data = (struct thread_info *) threadarg;
  fifo_buf* Times212_reshape0_IP0_buf_ptr = thread_data->get_fifo_buf_by_dst("Times212_reshape0_IP0");
 
  fifo_buf* Times212_reshape0_OP0_buf_ptr = thread_data->get_fifo_buf_by_src("Times212_reshape0_OP0");
 
 
  setaffinity(thread_data->core_id);
  // repetition parameters definition
  int q = 5;
  int phase_len = 5;
  int phase; 
 
  // while (1) {
    // loop over the repetitions number
    for (int rep = 0; rep < q ; rep ++) {
      phase = rep % phase_len;

      //reading
      //max tokens port IP0
      int IP0_tokens = 0;
      if (phase >= 1)
        IP0_tokens = 64; 
 
      // readSWF_CPU to Pooling160
      if(IP0_tokens>0)
    	  readSWF_CPU(Times212_reshape0_IP0_buf_ptr->fifo, &Pooling160[0][0][0], IP0_tokens, Times212_reshape0_IP0_buf_ptr->fifo_size);

      //execution
      appFunc::execute(std::string("RESHAPE"),&Pooling160[0][0][0], NULL, &output[0][0][0], &int_params);

      //writing
      //max tokens port OP0
      int OP0_tokens = 0;
      if (phase >= 4)
        OP0_tokens = 256; 
 
      // writeSWF_CPU to output
      if(OP0_tokens>0)
    	  writeSWF_CPU(Times212_reshape0_OP0_buf_ptr->fifo, &output[0][0][0], OP0_tokens, Times212_reshape0_OP0_buf_ptr->fifo_size);
    }// loop over the phases
  cout<<" Times212_reshape0 finished! "<<endl;
  //} while (1)
} // main
